<?php

                // The BOOKMARKSDB navigator			//
                // permission is granted to use modified copies //
		// of this program on condition that this	//
		// original copyright notice remains intact.	//
                //                                              //
		// Copyright 2001 Antonio Bonifati		//
		// <antonio.b@infinito.it>			//
		// <kiss@clubnautilus.net>			//
		//						//
                // distributed under GPL (see COPYING)          //

########## cgi arguments
# parent	id of the directory to list
#		(defaults to 0)
##########

// include the common function library
require 'admin/lib.php';

?>
<html>
<head><title>BookmarksDB</title></head>
<body bgcolor="#ffffff">
<h1 align="center">BookmarksDB</h1>
<hr noshade size=1>
<?php

// try to connect to the mSQL database server
// using permanent connection
try_msql_pconnect();

// try to open db DBNAME
try_msql_selectdb();

if (!isset($parent))
   $parent=0;	// starts from root for default

$qid=do_listing_query();

//// print bookmark directory

// if we are not at root print the special parent link
if ($parent)
{
   $qid2=msql_query("SELECT parent, name FROM bookmarks WHERE id=$parent");
   $row=msql_fetch_array($qid2, MSQL_ASSOC);
   printf(TITLEMARK . "\n" . PREVDIRMARK . ENDMARK . "\n",
	$row['name'], $row['parent']);
   msql_free_result($qid2);
}

// print the entries list
if (!msql_affected_rows($qid))
   echo EMPTYMARK, ENDMARK, "\n";
else
   while ($row=msql_fetch_array($qid, MSQL_ASSOC))
   {
     if ($row['type']=='D')	// directory
	printf(DIRMARK, '', $row['id'], htmlspecialchars($row['name']));
     else			// file
	printf(URLMARK,
	   protocol_name($row['type']) . '://' . $row['url'], htmlspecialchars($row['name']));

     if ($row[comment])
	printf(COMMENTMARK, strip_tags($row['comment']));
     echo ENDMARK . "\n";
   }

?>
<hr noshade size=1>
<font size=-2><?php if ($parent) echo '<a href="./">Root index</a> |'; ?>

<a href="search.php">Search</a> |
<a href="all.php">Expand only directories</a> |
<a href="all.php?withfile=">Expand all</a></font>
<h6 align="center">Copyright 2001
<a href="mailto:antonio.b@infinito.it">Antonio Bonifati</a>.
Distributed under <a href="COPYING">GPL</a>.</h6>
</body>
</html>
