<?php

                // The BOOKMARKSDB search			//
                // permission is granted to use modified copies //
		// of this program on condition that this	//
		// original copyright notice remains intact.	//
                //                                              //
		// Copyright 2001 Antonio Bonifati		//
		// <antonio.b@infinito.it>			//
		// <kiss@clubnautilus.net>			//
		//						//
                // distributed under GPL (see COPYING)          //

########## cgi arguments
# keyword	keyword to search (ignored if empty)
#
# at least one of this should be passed
# n		if not empty includes names in the search
# u		if not empty includes urls in the search
# c		if not empty includes comments in the search
#
# at least one of this should be passed
# f		if not empty includes files in the search
# d		if not empty includes directories in the search
##########

// include the common function library
require 'admin/lib.php';

?>
<html>
<head><title>BookmarksDB search</title></head>
<body bgcolor="#ffffff">
<h1 align="center">BookmarksDB search</h1>
<hr noshade size=1>
<form>
Keyword <input type=text name=keyword maxlenght=<?php

	// compute the max length of Keyword field
	echo max(nameCHARlen, urlCHARlen, commentCHARlen);

?>>
<input type=submit value=" Search ">
<table><tr>
<td>names</td><td><input type=checkbox name=n checked></td>
<td width=30>&nbsp;</td>
<td>files </td><td><input type=checkbox name=f checked></td>
</tr><tr>
<td>urls</td><td><input type=checkbox name=u checked></td>
<td width=30>&nbsp;</td>
<td>directories</td><td><input type=checkbox name=d checked></td>
</tr><tr>
<td>comments</td><td><input type=checkbox name=c checked></td>
<td colspan=3>&nbsp;</td>
</tr></table>
</form>
<?php

// strip whitespace from beginning and end of $keyword
$keyword=trim($keyword);

// quote ' in $keyword if PHP doesn't do that automagically
if (!get_magic_quotes_gpc())
   $keyword = addslashes($keyword);

// perform search and show result only if $keyword is set and is not ""
if ($keyword)
{
   // remember the user the type of search
   echo "<hr noshade size=1>\n<big>search for `<b>". htmlspecialchars(stripslashes($keyword)) .
        "</b>' </big>( ";
   if ($n) echo 'names ';
   if ($u) echo 'urls ';
   if ($c) echo 'comments ';
   echo '& ';
   if ($f) echo 'files ';
   if ($d) echo 'directories ';
   echo ")<p>\n";

   // try to connect to the mSQL database server
   // using permanent connection
   try_msql_pconnect();

   // try to open db DBNAME
   try_msql_selectdb();

   //// construct and launch the search query
   // this involves a bit of guided string concatenations
   $query = 'SELECT * FROM bookmarks WHERE ';
   if ($f && $d)
      ;
   elseif ($f)
      $query .= "type<>'D' AND";
   elseif ($d)
      $query .= "type='D' AND";
   else
      die("<font color=red>Search error: please choose one from `files' and `directories'". HTMLend);

   // let's define an helper function
   $first_term = TRUE;
   function or_query($cond)
   {
      global $query, $first_term;

      if (!$first_term) $query .= ' OR ';
      else $first_term = FALSE;

      $query .= $cond;
   }

   $query .= ' (';
   if ($n)
      or_query("name clike '%$keyword%'");
   if ($u)
      or_query("url clike '%$keyword%'");
   if ($c)
      or_query("comment clike '%$keyword%'");
   if ($first_term)
      die("<font color=red>Search error: please choose one from `names', `urls' and `comments'". HTMLend);
   $query .= ') '. (ORDERBY ? (' ORDER BY '. ORDERBY):(''));

   // show the SQL-QUERY; this is for debugging purposes only
   #echo "<i>SQL-QUERY</i>:<br><b>$query</b>\n";

   $qid=msql_query($query);

   //// print search result

   echo "<dl>\n";
   if (!msql_affected_rows($qid))
      echo EMPTYMARK, ENDMARK, "\n";
   else
      while ($row=msql_fetch_array($qid, MSQL_ASSOC))
	 if ($row['type']=='D')	// directory
	    printf('<dt>' . DIRMARK . ENDMARK . "\n<dd>%s\n",
		'', $row['id'], htmlspecialchars($row['name']), $row['comment']);
	 else			// file
	    printf('<dt>' . URLMARK . PARENTMARK . ENDMARK . "\n<dd>%s\n",
		protocol_name($row['type']) . '://' . $row['url'], htmlspecialchars($row['name']),
		$row['parent'], $row['comment']);
   echo "</dl>\n";
}

?>
<hr noshade size=1>
<font size=-2><a href="./">Root index</a> |
<a href="all.php">Expand only directories</a> |
<a href="all.php?withfile=">Expand all</a></font>
<h6 align="center">Copyright 2001
<a href="mailto:antonio.b@infinito.it">Antonio Bonifati</a>.
Distributed under <a href="COPYING">GPL</a>.</h6>
</body>
</html>
