<?php

                // The BOOKMARKSDB one page navigator admin	//
                // permission is granted to use modified copies //
		// of this program on condition that this	//
		// original copyright notice remains intact.	//
                //                                              //
		// Copyright 2001 Antonio Bonifati		//
		// <antonio.b@infinito.it>			//
		// <kiss@clubnautilus.net>			//
		//						//
                // distributed under GPL (see COPYING)          //

// include the common function library
require 'lib.php';

// prevents browsers from caching this document
// even if the NOCACHE in the CONF.php file is FALSE
if (!NOCACHE)
   no_cache();

?>
<html>
<head><title>BookmarksDB: all in one page - ADMIN</title></head>
<body bgcolor="#ffefd5">
<h1 align="center">BookmarksDB - all - ADMIN</h1>
<hr noshade size=1>
<?php

// try to connect to the mSQL database server
// using permanent connection
try_msql_pconnect();

// try to open db DBNAME
try_msql_selectdb();

if (!isset($parent))
   $parent=0;	// starts from root for default

printf(NEWMARK . '<p>', $parent);

// print a link to delete all of the db contents
printf('root' . DELETEMARK . ENDMARK . "\n", '0');

// print entire tree recursively
$reclevel=-1;
print_tree();

function print_tree()
{
   global $parent, $withfile, $reclevel;

   $reclevel++;

   $qid=do_listing_query((!isset($withfile)) ? ("AND type='D'") : (''));

   //// print bookmark directory

   if (!msql_affected_rows($qid))
   {
      if (isset($withfile) && EMPTYMARK)
      {
	 do_indent();
	 echo EMPTYMARK, ENDMARK, "\n";
      }
   }
   else
      while ($row=msql_fetch_array($qid, MSQL_ASSOC))
	 if ($row['type']=='D')	// directory
	 {
	    do_indent();

	    printf(DIRMARK . COMMENTMARK . DELETEMARK . EDITMARK . MOVEMARK . ENDMARK . "\n",
		basename(__FILE__), $row['id'], htmlspecialchars($row['name']), strip_tags($row['comment']),
		$row['id'], $row['id'], $row['id']);
	    $parent=$row['id'];
	    print_tree();
	 }
	 else			// file
	 {
	    do_indent();

	    printf(URLMARK . COMMENTMARK . DELETEMARK . EDITMARK . MOVEMARK . ENDMARK . "\n",
		protocol_name($row['type']) .'://'. $row['url'],
		htmlspecialchars($row['name']), strip_tags($row['comment']), $row['id'], $row['id'], $row['id']);
	 }

   $reclevel--;
   msql_freeresult($qid);
}

?>
<hr noshade size=1>
<font size=-2><a href="./">Root index</a> |
<a href="search.php">Search</a> |
<?php if (isset($withfile)): ?>
<a href="all.php">Expand only directories</a>
<?php else: ?>
<a href="all.php?withfile=">Expand all</a>
<?php endif; ?></font>
<h6 align="center">Copyright 2001
<a href="mailto:antonio.b@infinito.it">Antonio Bonifati</a>.
Distributed under <a href="COPYING">GPL</a>.</h6>
</body>
</html>
